<%@Language = VBScript%>
<%Option Explicit%>
<%
'Begin buffering the HTML so that no data is sent to the client browser until all processing is finished on the servers end.
Response.Buffer = True
%>
<!--#set var="queryString" value="$QUERY_STRING" -->
<!--#if expr="$queryString = /perform=post/" || expr="$queryString = /perform=admin&act=cancel/" || expr="$queryString = /perform=admin&act=createBackup/" || expr="$queryString = /perform=admin&act=rest/reBackup/" || expr="$queryString = /perform=admin&act=save/" || expr="$queryString = /perform=admin&act=delete/" || expr="$queryString = /perform=admin&act=writeHeader/" || expr="$queryString = /perform=admin&act=writeFooter/" || expr="$queryString = /perform=admin&act=logout/" || expr="$queryString = /perform=admin&act=checkPassword/" -->
<!--#include file="header.asp" -->
<!--#endif -->
<%
DIM postsArray() 'array of posts from text file
DIM postCount 'number of posts in total file
DIM i 'repeatedly used counting variable
DIM perform 'action the file is intended to perform
DIM fileLocation 'location of post file relative to this script file
DIM headerLocation 'location of content that is displayed at the top of each page relative to this script file
DIM headerContents 'contents of the header file
DIM newHeaderContents 'new contents of the header file
DIM footerLocation 'location of content that is displayed at the bottom of each page relative to this script file
DIM footerContents 'contents of the footer file
DIM newFooterContents 'new contents of the footer file
DIM deleteLocation 'location of deleted posts file relative to this script file
DIM postsPerPage 'amount of posts displayed on each page
DIM tableWidth 'width of table containing form and heading
Dim tableBg, personalInformationBg, msgBg, buttonBg 'Colors
DIM filePath 'path to file
DIM fileString 'FSO object
DIM theFile
DIM allPosts 'all the posts from text file (also doubles up for other similar variables)
DIM person 'users name
DIM message 'message typed by user
DIM email 'users email
DIM msn 'users msn address
DIM aim 'users aim account
DIM yahoo 'users yahoo account
DIM icq 'users ICQ UIN
DIM homepage 'users homepage
DIM datetime 'date and time (in String format) that user posted
DIM postedDatetime 'date and time (in String format) that user originally posted (used when editing a file, so users of site can still see when a post was originally posted
DIM password 'password for gaining access to admin areas
DIM pwd 'form entered password
DIM act 'action to be performed when in admin area
DIM postNumber 'id number of post to be edited/deleted
DIM submit 'variable for what button pressed
DIM signature 'signature appended to edited posts
DIM signatureToggle 'holds value defining whether a signature is placed in a posts message after editing
DIM importantText 'string holding hex for color of any important text that must stand out ( e.g. error messages, etc)

'get date and time from server
datetime=FormatDateTime(Date, 1) & "&nbsp;&nbsp;" & FormatDateTime(Now, 3)

'------------------------------------------------------------------------'
'-------------------------------READ HERE!-------------------------------'
'									 '
'NOTE: REMOVING COMMENTS MAY CAUSE THE SCRIPT TO CEASE OPERATING SINCE   '
'      THE ADMIN FUNCTION LOOKS FOR PARTICULAR COMMENTS!!!               '
'                                                                        '
'AUTHOR: Leigh McCulloch (http://www.shokem.com/)                        '
'Refer to file 'COPYING' for license.                                    '
'Refer to file 'INSTALL' for installation instructions.                  '
'Refer to file 'ChangeLog' for release history and changes.              '
'                                                                        '
'To edit the header and footer of both pages, edit the files header.asp  '
'and footer.asp.                                                         '
'                                                                        '
'password for administration areas                                       '
password="123"                                                           '
'                                                                        '
'amount of posts displayed on each page                                  '
postsPerPage=10                                                          '
'									 '
'signature displayed below posts that have been edited.			 '
'set signature to "" if not wanting to display a signature               '
signature=" (EDITED by Admin: " & datetime & ")"			 '
'                                                                        '
'guestbook database file location, relative to this file                 '
'header file location and footer file location				 '
'for unix/linux server: must have '/' in front of file name              '
'for windows server: must have '\' in front of file name                 '
fileLocation="/guestbook.txt"                                            '
headerLocation="/header.asp"						 '
footerLocation="/footer.asp"                                             '
'                                                                        '
'deleted entries database file location, relative to this file           '
'for unix/linux server: must have '/' in front of file name              '
'for windows server: must have '\' in front of file name                 '
deleteLocation="/guestbook-deleted.txt" '(NOT YET IMPLMENTED)            '
'                                                                        '
'width of table containing form and heading for Sign Guestbook page      '
tableWidth="400"                                                         '
'                                                                        '
'Colors, in hex (Run on server first to see which color is which.)       '
tableBg="FFFFFF" 'bg color of whole table and heading (not page bg)      '
personalInformationBg="FFD96C" 'bg color for personal information box's  '
msgBg="FFAA00" 'bg color for message text area box                       '
buttonBg="3ED85B" 'bg color for 'submit' button's box                    '
importantText="FF0000" 'text color for error messages, etc               '
'                                                                        '
'                                                                        '
'-------------------------------||-CODE-||-------------------------------'
'-------------------------------\/------\/-------------------------------'

'set variables containing arguments
newHeaderContents = Request.Form("newHeaderContents")
newFooterContents = Request.Form("newFooterContents")
perform = replace(Request("perform"),"""","&quot;")
signatureToggle = replace(Request("signatureToggle"),"""","&quot;")
submit = replace(Request.Form("Submit"),"""","&quot;")
act = replace(Request.Form("act"),"""","&quot;")
pwd = replace(Request.Form("pwd"),"""","&quot;")
postNumber = replace(Request.Form("postNumber"),"""","&quot;")
email = replace(Request.Form("EMail"),"""","&quot;")
msn = replace(Request.Form("MSN"),"""","&quot;")
aim = replace(Request.Form("AIM"),"""","&quot;")
yahoo = replace(Request.Form("Yahoo"),"""","&quot;")
icq = replace(Request.Form("ICQ"),"""","&quot;")
If (replace(Request.Form("Homepage"),"""","&quot;")) = "http://" THEN
	homepage = ""
ELSE 
	homepage = replace(Request.Form("Homepage"),"""","&quot;")
END IF
If replace(Request.Form("Message"),"""","&quot;") = "" THEN
	message = "No Message"
ELSE
	message = replace(Request.Form("Message"),"""","&quot;")
END IF
If replace(Request.Form("Person"),"""","&quot;") = "" THEN
	person = "unkown"
ELSE
	person = replace(Request.Form("Person"),"""","&quot;")
END IF

'replace '^' with '&#94;' - changed by Leigh McCulloch, 2002-11-05
person = replace(person,"^","&#94;")
email = replace(email,"^","&#94;")
msn = replace(msn,"^","&#94;")
aim = replace(aim,"^","&#94;")
yahoo = replace(yahoo,"^","&#94;")
icq = replace(icq,"^","&#94;")
homepage = replace(homepage,"^","&#94;")
message = replace(message,"^","&#94;")

'replace '|' with '&#124;' - added by Leigh McCulloch, 2002-11-05
person = replace(person,"|","&#124;")
email = replace(email,"|","&#124;")
msn = replace(msn,"|","&#124;")
aim = replace(aim,"|","&#124;")
yahoo = replace(yahoo,"|","&#124;")
icq = replace(icq,"|","&#124;")
homepage = replace(homepage,"|","&#124;")
message = replace(message,"|","&#124;")

'check whether the user has logged in
IF ((NOT (Session("guestbookAgent") = "SKGB" AND (Session("pwd") = "SKGB" & postsPerPage & tableWidth & password & tableBg & personalInformationBg & msgBg & buttonBg & "SKGB"))) AND perform="admin") THEN
	perform="login"
END IF

'read guestbook text file
IF (perform="post" OR perform="view" OR perform="details" OR (perform="admin" AND (act= "" OR ((act="restoreBackup" OR act="createBackup" OR act="options") AND NOT submit="Cancel") OR act="save" OR act="delete"))) THEN
	'specify the file containing the posts
	filePath=server.mappath(".") & fileLocation
	
	'NOTE: Because adding post to beginning of file, can't use 'append' feature, must rewrite file.
	'open the file for reading
	Set fileString = CreateObject("Scripting.FileSystemObject")
	IF (perform="admin" AND act="restoreBackup") THEN
		IF fileString.FileExists(filePath & ".backup")=true THEN
			Set theFile = fileString.OpenTextFile((filePath & ".backup"), 1, False)
			'store all the posts in a variable and then close
			allPosts = theFile.readall
			theFile.Close
		END IF
	ELSEIF (perform="admin" AND act="options") THEN
		filePath = server.mappath(".") & headerLocation
		Set theFile = fileString.OpenTextFile(filePath, 1, False)
		headerContents = theFile.readall
		theFile.Close
		filePath = server.mappath(".") & footerLocation
		Set theFile = fileString.OpenTextFile(filePath, 1, False)
		footerContents = theFile.readall
		theFile.Close
	ELSE
		Set theFile = fileString.OpenTextFile(filePath, 1, True)
		'store all the posts in a variable and then close
		allPosts = theFile.readall
		theFile.Close
	END IF
END IF

IF (perform="admin" AND submit="Cancel") THEN
	Response.Clear
	Response.Redirect("?perform=admin")

ELSEIF perform="post" THEN
	'open the file for writing
	Set fileString = Server.CreateObject("Scripting.FileSystemObject") 
	Set theFile = fileString.OpenTextFile(filePath, 2, True)

	'Write the contents of the text file
	theFile.WriteLine(person)
	theFile.WriteLine("|" & datetime)
	theFile.WriteLine("|" & email)
	theFile.WriteLine("|" & msn)
	theFile.WriteLine("|" & aim)
	theFile.WriteLine("|" & yahoo)
	theFile.WriteLine("|" & icq)
	theFile.WriteLine("|" & homepage)
	theFile.WriteLine("|" & message & "^")
	theFile.WriteBlankLines(1)
	theFile.WriteLine(allPosts)
 
	'Close the file and remove objects
	theFile.Close
	set theFile=nothing
	set fileString=nothing

	Response.Clear
	Response.redirect("?perform=view")

ELSEIF (perform="admin" AND act="restore") THEN
	Response.write("<B>Restore From Recovery Backup File</B><BR><BR>")
	Response.write("If you click 'OK', the current file will be deleted and replaced with the backup file.<BR><BR>The backup file is created each time a post is edited or deleted with the 'Administration' page. <B><FONT COLOR=#" & importantText & ">It is not created when users sign the guestbook, or when any other changes are made with the 'Administration' page</FONT></B> (e.g. appearance changes, etc). It's only purpose is to serve as a resource if this script fails whilst you are editing or deleting a post.<BR><BR>NOTE: Once you click 'OK' the backup guestbook file will be copied over replacing the current guestbook file. The current guestbook file will be lost, and irrecoverable.<BR><BR>")
	Response.write("<FORM NAME=guestbook METHOD=post ACTION=?perform=admin>")
	Response.write("<INPUT TYPE=hidden NAME=act VALUE='restoreBackup'>")
	Response.write("<INPUT TYPE=submit NAME=Submit VALUE='  Ok  '>&nbsp;&nbsp;&nbsp;")
	Response.write("<INPUT TYPE=submit NAME=Submit VALUE=Cancel>")
	Response.write("</FORM>")
	Response.write("<BR><BR><BR><B>How To Make Effective Backups</B><BR><BR>")
	Response.write("Click the button below to read this section.<BR><BR>")
	Response.write("<FORM NAME=backup METHOD=post ACTION=?perform=admin>")
	Response.write("<INPUT TYPE=submit NAME=Submit VALUE='Redirect to Section'>")
	Response.write("<INPUT TYPE=hidden NAME=act VALUE='backup'>")
	Response.write("</FORM>")

ELSEIF (perform="admin" AND act="backup") THEN
	Response.write("<B>Create Backup of Guestbook Post File</B><BR><BR>")
	Response.write("If you click 'OK', the current backup file will be deleted and replaced with the current guestbook file.<BR><BR>The backup file is created each time a post is edited or deleted with the 'Administration' page. So this next time this happens, this file you are creating now will be overwritten. <B><FONT COLOR=#" & importantText & ">It is not however created when users sign the guestbook, or when any other changes are made with the 'Administration' page</FONT></B> (e.g. appearance changes, etc). Similarily this backup will only hold the contents of the guestbook posts file, and not any other settings. <BR><BR>NOTE: Once you click 'OK' the backup guestbook file will be replaced with the current guestbook posts file. The current backup file will be lost, and irrecoverable.<BR><BR>")
	Response.write("<FORM NAME=guestbook METHOD=post ACTION=?perform=admin>")
	Response.write("<INPUT TYPE=hidden NAME=act VALUE='createBackup'>")
	Response.write("<INPUT TYPE=submit NAME=Submit VALUE='  Ok  '>&nbsp;&nbsp;&nbsp;")
	Response.write("<INPUT TYPE=submit NAME=Submit VALUE=Cancel>")
	Response.write("</FORM>")
	Response.write("<BR><BR><BR><B>How To Make Effective Backups</B><BR><BR>")
	Response.write("As you would notice, the backup features of this script only provide for those who have encounted problems while editing or deleting posts. The reason for this is because it would be pointless to create backups onto the same server as this script.<BR><BR>The role of a backup of this kind, is to provide a source of information, if the server with the original file, goes down or is somehow caused to lose data. Considering any backup functions would create a backup file onto the same server as original file, if the server went down you would lose both the original and the backup - defeating the purpose of it.<BR><BR>For this reason I suggest manual backup of files be used. Depending on how often people submit posts to this guestbook, a backup should be created every two days. This can be done by copying the file off the server (using FTP or HTTP is your server allows it) to another location. If a failure occurs, the backup file can then be used.<BR><BR>")
	Response.write("<FORM NAME=guestbook METHOD=post ACTION=?perform=admin>")
	Response.write("<INPUT TYPE=submit NAME=Submit VALUE='<< Previous Page'>")
	Response.write("</FORM>")

ELSEIF (perform="admin" AND act="restoreBackup") THEN
	IF fileString.FileExists(filePath)=true THEN
		fileString.DeleteFile(filePath)
	END IF
	IF fileString.FileExists(filePath & ".backup")=true THEN
		Set theFile = fileString.OpenTextFile(filePath, 2, True)
		theFile.WriteLine(allPosts)
		theFile.Close
		Response.Clear
		Response.redirect("?perform=admin")
	ELSE
		Response.write("<B><FONT COLOR=#" & importantText & ">ERROR: No Recovery Backup File exists in the same directory as this script file. If you feel this is incorrect, re-read the information on the previous page.</FONT></B>")
	END IF

ELSEIF (perform="admin" AND act="createBackup") THEN
	IF fileString.FileExists(filePath & ".backup")=true THEN
		fileString.DeleteFile(filePath & ".backup")
	END IF
	Set theFile = fileString.OpenTextFile((filePath & ".backup"), 2, True)
	theFile.WriteLine(allPosts)
	theFile.Close
	Response.Clear
	Response.redirect("?perform=admin")

ELSEIF (perform="admin" AND (act="save" OR act="delete")) THEN
	'make backup of guestbook text file
	'this is extremely necessary in this case,
	'since if the script was to hav an error after deleting the file,
	'and before rewriting it, all posts would be lost.
	Set theFile = fileString.OpenTextFile((filePath & ".backup"), 2, True)
	theFile.WriteLine(allPosts)
	theFile.Close

	'determine how many posts in total guestbook  
	postCount = 0
	FOR i = 1 to len(allPosts)
		IF mid(allPosts,i,1) = "^" THEN
			postCount = postCount + 1
		END IF 
	NEXT 

	'determine true post number from postNumber
	postNumber = ((postCount+1)-postNumber)

	REDIM postsArray(postCount-1) 'set array length

	'place posts into seperate array index's instead of one String
	FOR i=0 to postCount-1
		postsArray(i) = left(allPosts,instr(allPosts, "^"))
		allPosts = mid(allPosts,instr(allPosts, "^")+1)
	NEXT

	'create objest
	Set fileString = Server.CreateObject("Scripting.FileSystemObject") 

	'remove the current guestbook file.
	'This is necessary since some servers handle this operation differently.
	'Because the file is getting smaller in length when deleting, some servers will retain
	'anything not written over. And so will cause errors in the 'view' and other pages.
	fileString.DeleteFile(filePath)

	'create new file for edited guestbook entries
	Set theFile = fileString.OpenTextFile(filePath, 2, True)

	'write posts back to the index file
	FOR i=0 to postCount-1
		IF (act="delete" AND i=postNumber-1) THEN
			'write to deleted entries file (NOT YET IMPLEMENTED)
		ELSEIF (act="save" AND i=postNumber-1) THEN
			'get original post datetime
			pipe = instr(postsArray(i),"|")
			postsArray(i) = mid(postsArray(i),pipe + 1)
			pipe = instr(postsArray(i),"|")
			postedDatetime = left(postsArray(i),pipe - 1)
			
			'write new values
			theFile.WriteLine(person)
			theFile.WriteLine("|" & postedDatetime)
			theFile.WriteLine("|" & email)
			theFile.WriteLine("|" & msn)
			theFile.WriteLine("|" & aim)
			theFile.WriteLine("|" & yahoo)
			theFile.WriteLine("|" & icq)
			theFile.WriteLine("|" & homepage)
			theFile.Write("|" & message)
			IF (NOT signature="" AND signatureToggle="1") THEN
				theFile.Write(vbCrLf & vbCrLf)
				theFile.WriteLine(signature)
			END IF
			theFile.Write("^")
			theFile.WriteBlankLines(1)
		ELSE
			theFile.WriteLine(postsArray(i))
		END IF
	NEXT
 
	'Close the file and remove objects
	theFile.Close
	set theFile=nothing
	set fileString=nothing

	Response.Clear
	Response.Redirect("?perform=admin")

ELSEIF (perform="admin" AND (act="options" OR act="advoptions")) THEN
	IF act="advoptions" THEN
		Response.write("<B>Advanced Options</B>")
		Response.write("<BR><BR>Password: " & password)
		Response.write("<BR><BR>GB File Location: <FONT COLOR=#999999>" & server.mappath(".") & "</FONT>" & fileLocation)
		Response.write("<BR>Header Location: <FONT COLOR=#999999>" & server.mappath(".") & "</FONT>" & headerLocation)
		Response.write("<BR>Footer Location: <FONT COLOR=#999999>" & server.mappath(".") & "</FONT>" & footerLocation & "<BR><BR>")
		Response.write("<FORM NAME=restore METHOD=post ACTION=?perform=admin>")
		Response.write("<INPUT TYPE=submit NAME=Submit VALUE='Restore from Backup'>")
		Response.write(" - IMPORTANT: Click for function description.")
		Response.write("<INPUT TYPE=hidden NAME=act VALUE='restore'>")
		Response.write("</FORM><BR>")
		Response.write("<FORM NAME=restore METHOD=post ACTION=?perform=admin>")
		Response.write("<INPUT TYPE=submit NAME=Submit VALUE='Create Backup'>")
		Response.write(" - IMPORTANT: Click for function description.")
		Response.write("<INPUT TYPE=hidden NAME=act VALUE='backup'>")
		Response.write("</FORM>")
	ELSE
		Response.write("<B>Appearance</B><BR><BR>")
		Response.write("<FORM NAME=headerContents METHOD=post ACTION=?perform=admin>")
		Response.write("<INPUT TYPE=hidden NAME=act Value='writeHeader'>")
		Response.write("Header File: Appears above posts on each page of the guestbook.<BR>")
		Response.write("<TEXTAREA Name=newHeaderContents rows='15' cols='60'>" & headerContents & "</TEXTAREA><BR>")
		Response.write("<INPUT TYPE=Submit NAME=Submit VALUE=Save>&nbsp;&nbsp;&nbsp;")
		Response.write("<INPUT TYPE=Reset NAME=Revert VALUE=Revert>")
		Response.write("</FORM><BR><BR>")
		Response.write("<FORM NAME=footerContents METHOD=post ACTION=?perform=admin>")
		Response.write("<INPUT TYPE=hidden NAME=act Value='writeFooter'>")
		Response.write("Footer File: Appears below posts on each page of this guestbook.<BR>")
		Response.write("<TEXTAREA Name=newFooterContents rows='15' cols='60'>" & footerContents & "</TEXTAREA><BR>")
		Response.write("<INPUT TYPE=Submit NAME=Submit VALUE=Save>&nbsp;&nbsp;&nbsp;")
		Response.write("<INPUT TYPE=Reset NAME=Revert VALUE=Revert>")
		Response.write("</FORM><BR><B>NOTE:</B> Depending on the caching habits of your hosting server. The above scripts may take up to 20 minutes to change appearance.<BR>")
		Response.write("<BR>Posts Per Page: " & postsPerPage)
		Response.write("<BR>Signature: " & signature)
		Response.write("&nbsp;&nbsp;<I>(Inserted after edited posts)</I>")
		Response.write("<BR>Table Width: " & tableWidth & " pixels")
		Response.write("&nbsp;&nbsp;<I>(Sign Guestbook page only)</I>")
		Response.write("<BR><BR><I>Colors:</I>")
		Response.write("<BR>&nbsp;&nbsp;Text Color: Must be edited in the header file.")
		Response.write("<BR>&nbsp;&nbsp;Table Background: #" & tableBg)
		Response.write("<BR>&nbsp;&nbsp;Personal Information Background: #" & personalInformationBg)
		Response.write("<BR>&nbsp;&nbsp;Message Area Background: #" & msgBg)
		Response.write("<BR>&nbsp;&nbsp;Submit Button Background: #" & buttonBg)
		Response.write("&nbsp;&nbsp;<I>(Sign Guestbook page only)</I>")
		Response.write("<BR>&nbsp;&nbsp;Important Text Color: #" & importantText)
	END IF
	Response.write("<BR><BR><B>NOT YET IMPLEMENTED</B><BR>These variables can be edited manually in the 'READ THIS!' section this script file (e.g. guestbook.asp).")

ELSEIF (perform="admin" AND (act="writeHeader" OR act="writeFooter")) THEN
	IF act="writeHeader" THEN
		filePath = server.mappath(".") & headerLocation
	ELSE
		filePath = server.mappath(".") & footerLocation
	END IF
	Set fileString = Server.CreateObject("Scripting.FileSystemObject") 
	fileString.DeleteFile(filePath)
	Set theFile = fileString.OpenTextFile(filePath, 2, True)
	IF act="writeHeader" THEN
		theFile.Write(newHeaderContents)
	ELSE
		theFile.Write(newFooterContents)
	END IF
	theFile.Close
	set theFile=nothing
	set fileString=nothing
	Response.Clear
	Response.redirect("?perform=admin")

ELSEIF (perform="admin" AND act="logout") THEN
	Session("guestbookAgent") = ""
	Session("pwd") = ""
	Response.Clear
	Response.Redirect("?perform=admin")

ELSEIF (perform="login" AND act="checkPassword") THEN
	IF pwd = password THEN
    		Session("guestbookAgent") = "SKGB"
		Session("pwd") = "SKGB" & postsPerPage & tableWidth & password & tableBg & personalInformationBg & msgBg & buttonBg & "SKGB"
		Response.Clear
		Response.Redirect("?perform=admin")
	ELSE
		Response.Clear
		Response.Redirect("?perform=login")
	END IF

ELSEIF (perform="login") THEN 'added by Leigh McCulloch, 2002-11-09
	Response.write(FormatDateTime(Date, 1) & "&nbsp;&nbsp;" & FormatDateTime(Now, 3))
	Response.write("<BR><BR><B>Administration Login</B><BR><BR>")
	IF password="123" THEN
		Response.write("Password: " & password & " <I><FONT SIZE=-2>(This line is only displayed when the script's password is '123'.)</FONT></I><BR><BR>")
	END IF
	Response.write("Please enter the Administration password below.<BR><BR>")
	Response.write("<FORM NAME=adminlogin METHOD=post ACTION=?perform=login>")
	Response.write("<INPUT TYPE=hidden NAME=act VALUE='checkPassword'>")
	Response.write("<INPUT TYPE=password size=25 NAME=pwd>")
	Response.write("<INPUT TYPE=submit NAME=Submit VALUE='Login'>")
	Response.write("</FORM>")

ELSEIF ((perform="view") OR (perform="details") OR (perform="admin")) THEN
	DIM pageNumber 'page number to display of guestbook
	DIM maxNumberOfPossiblePosts 'maximum number of possible posts that could be held on the amount of pages
	DIM difference 'difference between first post on page, and last post on page
	DIM firstPostNumber 'number of first post on page
	DIM lastPostNumber 'number of last post on page
	DIM pageList 'list of page's available
	DIM totalPages 'total amount of pages
	DIM pipe 'pipeline used in variable assignment
	DIM bracketNumber 'number that starts for each square bracket in the pageList
	DIM distanceFromTensValue 'distance from the closest 'tens' value

	pageNumber = Request("p")
	IF pageNumber="" THEN
		pageNumber=1 'if no page number selected, set to page 1 (latest posts)
	END IF

	'determine how many posts in total guestbook  
	postCount = 0
	FOR i = 1 to len(allPosts)
		IF mid(allPosts,i,1) = "^" THEN
			postCount = postCount + 1
		END IF 
	NEXT 

	'determine first and last post numbers to be published on current page
	maxNumberOfPossiblePosts=pageNumber*postsPerPage 'maximum number of possible posts that could be held on the amount of pages
	difference=((postCount/postsPerPage)-((-Int(-(postCount/postsPerPage-1)))-1))*postsPerPage-postsPerPage 'difference between first and last post number for page
	IF postCount-1>=maxNumberOfPossiblePosts-postsPerPage THEN
		IF (maxNumberOfPossiblePosts-postsPerPage+difference)<postCount THEN
			lastPostNumber=(pageNumber*postsPerPage)
			firstPostNumber=(lastPostNumber-postsPerPage)
		ELSE
			lastPostNumber=(maxNumberOfPossiblePosts-postsPerPage+difference)
			firstPostNumber=(lastPostNumber-1) - (difference-1)
		END IF
	ELSE 'incase something goes wrong will revert to first page
		firstPostNumber=0
		lastPostNumber=firstPostNumber+difference
	END IF
	
	REDIM postsArray(postCount-1) 'set array length

	'place posts into seperate array index's instead of one String
	FOR i=0 to postCount-1
		postsArray(i) = left(allPosts,instr(allPosts, "^")-1)
		allPosts = mid(allPosts,instr(allPosts, "^")+1)
	NEXT

	'set pageList to an empty string
	pageList=""

	'create page list in string - edited by Leigh McCulloch, 2002-11-09
	pageList=pageList & "Page: "
	IF (pageNumber-1)<=0 THEN
		pageList=pageList & "&lt;&lt;&nbsp;"
	ELSE
		pageList=pageList & "<A HREF=?perform=" & perform & "&p="
		pageList=pageList & (pageNumber-1)
		pageList=pageList & ">&lt;&lt;</A>&nbsp;"
	END IF

	totalPages=(-Int(-(postCount/postsPerPage-1)))
	IF totalPages=postCount/postsPerPage THEN
		totalPages=totalPages-1
	END IF

	FOR i=0 TO totalPages
		bracketNumber = (-Int(-(totalPages/10)))*10-i
		distanceFromTensValue = (-Int(-(totalPages/10)))*10-totalPages-1
		IF (-Int(-((totalPages-(i-1))/10)))=(-Int(-((totalPages-(pageNumber-1-1))/10))) THEN
			IF i=pageNumber-1 THEN
				pageList=pageList & "<B>["
				pageList=pageList & (-Int(-(postCount/postsPerPage-i)))		
				pageList=pageList & "]</B>"
			ELSE
				pageList=pageList & "<A HREF=?perform=" & perform & "&p="
				pageList=pageList & (i+1)
				pageList=pageList & "><U>"
				pageList=pageList & (-Int(-(postCount/postsPerPage-i)))
				pageList=pageList & "</U></A>"
			END IF
			IF i=totalPages THEN
			ELSE
				pageList=pageList & " "
			END IF
		ELSE
			i=i+9
			bracketNumber = (-Int(-(totalPages/10)))*10-i-distanceFromTensValue
			IF (bracketNumber+9)>totalPages THEN
				bracketNumber = totalPages-8
			END IF
			pageList=pageList & "<A HREF=?perform=" & perform & "&p=" & (i-8) & ">[" & (bracketNumber+9) & "-"
			IF bracketNumber<=1 THEN
				pageList=pageList & "1]</A>"
			ELSEIF bracketNumber+9=totalPages+1 THEN
				pageList=pageList & (bracketNumber+distanceFromTensValue) & "]</A> "
				i=i-distanceFromTensValue
			ELSE
				pageList=pageList & (bracketNumber) & "]</A> "
			END IF
		END IF
	NEXT

	IF (pageNumber-1)>=totalPages THEN
		pageList=pageList & "&nbsp;&gt;&gt;"
	ELSE '
		pageList=pageList & "&nbsp;<A HREF=?perform=" & perform & "&p="
		pageList=pageList & (pageNumber+1)
		pageList=pageList & ">&gt;&gt;</A>"
	END IF

	'write html for heading and top of table
	Response.write("<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH='100%'>")
	Response.write("  <TR>")
	Response.write("   <TD>")
	Response.write("    <TABLE BGCOLOR=#" & tableBg & " BORDER=0 WIDTH='100%' CELLSPACING=1 CELLPADDING=4>")
	Response.write("      <TR>")
	Response.write("       <TD><FONT SIZE=-1><B>Guestbook: ")
	IF perform="admin" THEN
		Response.write("<FONT COLOR=#" & importantText & ">Administration</FONT>")
	ELSE
		Response.write("Read the Guestbook")
	END IF
	Response.write(": Page " & (-Int(-(postCount/postsPerPage-(pageNumber-1)))))
	Response.write("	</B></FONT></TD></TR><TR><TD>")

	'write form linking to 'advanced options' editing - added by Leigh McCulloch, 2002-11-09
	IF perform = "admin" THEN
		Response.write("<FORM NAME=options METHOD=post ACTION=?perform=admin>")
		Response.write("<INPUT TYPE=submit NAME=Submit VALUE='Appearance'>")
		Response.write(" - Color theme, Posts Per Page, Template")
		Response.write("<INPUT TYPE=hidden NAME=act VALUE='options'>")
		Response.write("</FORM>")
		Response.write("<FORM NAME=advoptions METHOD=post ACTION=?perform=admin>")
		Response.write("<INPUT TYPE=submit NAME=Submit VALUE='Advanced Options'>")
		Response.write(" - Password, File Locations, Backup Features")
		Response.write("<INPUT TYPE=hidden NAME=act VALUE='advoptions'>")
		Response.write("</FORM>")
		Response.write("<FORM NAME=logout METHOD=post ACTION=?perform=admin>")
		Response.write("<INPUT TYPE=submit NAME=Submit VALUE='Logout'>")
		Response.write("<INPUT TYPE=hidden NAME=act VALUE='logout'>")
		Response.write("</FORM>")
	END IF

	'write link to 'sign guestbook' page
	Response.write("<FONT SIZE=-1><A HREF=?perform=sign>Sign the Guestbook</A><BR><BR>")
	
	'write page list links
	Response.write(pageList)
	Response.write("<BR><BR>")

	'write start of table
	Response.write("<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2 WIDTH='100%'>")
	
	'create variables and write them inside html
	FOR i=firstPostNumber to lastPostNumber-1
		allPosts = postsArray(i)
	
		'replace '<', '>' with '&lt;', '&gt;' - added by Leigh McCulloch, 2002-11-04
		allPosts = replace(allPosts,">","&gt;")
		allPosts = replace(allPosts,"<","&lt;")
	
		'Person
		pipe = instr(allPosts,"|")
		person = left(allPosts,pipe - 1)
		allPosts = mid(allPosts,pipe + 1)

		'Date and Time
		pipe = instr(allPosts,"|")
		datetime = left(allPosts,pipe - 1)
		allPosts = mid(allPosts,pipe + 1)

		'EMAIL
		pipe = instr(allPosts,"|")
		email = left(allPosts,pipe - 1)
		allPosts = mid(allPosts,pipe + 1)

		'MSN
		pipe = instr(allPosts,"|")
		msn = left(allPosts,pipe - 1)
		allPosts = mid(allPosts,pipe + 1)

		'AIM
		pipe = instr(allPosts,"|")
		aim = left(allPosts,pipe - 1)
		allPosts = mid(allPosts,pipe + 1)

		'Yahoo!
		pipe = instr(allPosts,"|")
		yahoo = left(allPosts,pipe - 1)
		allPosts = mid(allPosts,pipe + 1)

		'ICQ
		pipe = instr(allPosts,"|")
		icq = left(allPosts,pipe - 1)
		allPosts = mid(allPosts,pipe + 1)

		'Homepage
		pipe = instr(allPosts,"|")
		homepage = left(allPosts,pipe - 1)
		allPosts = mid(allPosts,pipe + 1)

		'Message
		allPosts = trim(allPosts)
		IF perform="admin" THEN
			message = allPosts
		ELSE
			message = replace(allPosts,vbcrlf,"<BR>")
		END IF

		'write to html for posts viewing/editing
		IF perform="admin" THEN
			Response.write("<FORM NAME=guestbook METHOD=post ACTION=?perform=admin>")
		END IF

		Response.write("<TR><TD VALIGN=middle WIDTH=10 BGCOLOR=#" & msgBg & "><B><FONT FACE=Arial Size=-1 COLOR=#" & tableBg & ">" & ((postCount+1)-(i+1)) & "</FONT></B></TD><TD VALIGN=top COLSPAN=1 BGCOLOR=#" & personalInformationBg & "><I><B>")

		IF perform="admin" THEN
			Response.write("<INPUT TYPE=text NAME=Person SIZE=20 VALUE='" & person & "'>")
		ELSE
			Response.write(person)
		END IF

		Response.write("</B>&nbsp;&nbsp;</I></TD><TD VALIGN=top WIDTH=5 BGCOLOR=#" & personalInformationBg & ">&nbsp;</TD><TD VALIGN=middle COLSPAN=3 BGCOLOR=#" & personalInformationBg & "><FONT SIZE=-1>")

		IF perform="admin" THEN
			Response.write("Homepage: <INPUT TYPE=text NAME=Homepage SIZE=50 VALUE='" & homepage & "'>")
		ELSE
			Response.write("<A HREF='" & homepage & "' target=_blank>" & homepage & "</A>")
		END IF

		Response.write("</FONT></TD></TR><TR><TD VALIGN=top WIDTH=5 BGCOLOR=#" & tableBg & ">&nbsp;</TD><TD VALIGN=top WIDTH=200  BGCOLOR=#" & tableBg & "><FONT SIZE=-2>" & datetime & "<BR><BR>")

		'write form to link to deleting current post
		IF perform="admin" THEN
			Response.write("<INPUT TYPE=radio NAME=act VALUE=save>Save")
			Response.write("<INPUT TYPE=radio NAME=act VALUE=delete>Delete<BR>")
			Response.write("<INPUT TYPE=checkbox NAME=signatureToggle VALUE=1 CHECKED>Display Signature<BR>")
			Response.write("<INPUT TYPE=hidden NAME=postNumber VALUE='" & ((postCount+1)-(i+1)) & "'>")
			Response.write("<INPUT TYPE=submit NAME=Submit VALUE='Save / Delete'>")
			Response.write("<BR><BR>")
		END IF

		Response.write("E-Mail:")
		IF perform="admin" THEN
			Response.write("<BR><INPUT TYPE=text NAME=EMail SIZE=20 VALUE='" & email & "'>")
		ELSE
			Response.write(" <A HREF='mailto:" & email & "'>" & email & "</A>")
		END IF

		Response.write("<BR><BR>MSN:")
		IF perform="admin" THEN
			Response.write("<BR><INPUT TYPE=text NAME=MSN SIZE=20 VALUE='" & msn & "'>")
		ELSE
			Response.write(" <A HREF=http://members.msn.com/" & msn & ">" & msn & "</A>")
		END IF

		Response.write("<BR>ICQ:")
		IF perform="admin" THEN
			Response.write("<BR><INPUT TYPE=text NAME=ICQ SIZE=20 VALUE='" & icq & "'>")
		ELSE
			Response.write(" <A HREF=http://www.icq.com/" & icq & " target=_blank>" & icq & "</A>")
		END IF

		Response.write("<BR>Yahoo!:")
		IF perform="admin" THEN
			Response.write("<BR><INPUT TYPE=text NAME=Yahoo SIZE=20 VALUE='" & yahoo & "'>")
		ELSE
			Response.write(" " & yahoo)
		END IF

		Response.write("<BR>AIM:")
		IF perform="admin" THEN
			Response.write("<BR><INPUT TYPE=text NAME=AIM SIZE=20 VALUE='" & aim & "'>")
		ELSE
			Response.write(" " & aim)
		END IF

		Response.write("</FONT></TD><TD VALIGN=top WIDTH=5 BGCOLOR=#" & buttonBg & ">&nbsp;</TD><TD VALIGN=top BGCOLOR=#" & tableBg & ">")

		IF perform="admin" THEN
			Response.write("<TEXTAREA Name='Message' rows='15' cols='60'>" & message & "</TEXTAREA>")
		ELSE
			Response.write(message)
		END IF

		Response.write("</TD></TR><TR><TD COLSPAN=4 BGCOLOR=#" & tableBg & " CELLPADDING=3><IMG SRC='dot-green.gif' BORDER=0 WIDTH='100%' HEIGHT=2><BR><BR></TD></TR></FORM>")
	NEXT
	
	'write end of table
	response.write("</TABLE><BR>")

	'write page list links
	Response.write(pageList)

	'write end of other tables
	response.write("</TD></TR></TABLE></TD></TR></TABLE>")

ELSE
	Response.write("<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH=" & tableWidth &">")
	Response.write("  <TR>")
	Response.write("   <TD>")
	Response.write("    <TABLE BGCOLOR=#" & tableBg & " BORDER=0 WIDTH=100% CELLSPACING=1 CELLPADDING=4>")
	Response.write("      <TR>")
	Response.write("       <TD><FONT FACE=Arial SIZE=-1><B>Guestbook: Sign the Guestbook</B></FONT></TD>")
	Response.write("      </TR>")
	Response.write("      <TR>")
	Response.write("       <TD><FONT FACE=Arial SIZE=-1>")
	Response.write("")
	Response.write("	<A HREF=?perform=view>Read the Guestbook</A><BR><BR>")
	Response.write("")
	Response.write("	<FORM NAME=guestbook METHOD=post ACTION=?perform=post>")
	Response.write("")
	Response.write("	  <TABLE CELLSPACING=0 CELLPADDING=4>")
	Response.write("	    <TR>")
	Response.write("	     <TD VALIGN=top BGCOLOR=#" & personalInformationBg & "><FONT FACE=Arial SIZE=-1>Name:</FONT></TD>")
	Response.write("	     <TD BGCOLOR=#" & personalInformationBg & "><INPUT TYPE=text NAME=Person SIZE=30></TD>")
	Response.write("	    </TR>")
	Response.write("	    <TR>")
	Response.write("	     <TD VALIGN=top BGCOLOR=#" & personalInformationBg & "><FONT FACE=Arial SIZE=-1>E-Mail:</FONT></TD>")
	Response.write("	     <TD BGCOLOR=#" & personalInformationBg & "><INPUT TYPE=text NAME=EMail SIZE=30></TD>")
	Response.write("	    </TR>")
	Response.write("	    <TR>")
	Response.write("	     <TD VALIGN=top BGCOLOR=#" & personalInformationBg & "><FONT FACE=Arial SIZE=-1>MSN:</FONT></TD>")
	Response.write("	     <TD BGCOLOR=#" & personalInformationBg & "><INPUT TYPE=text NAME=MSN SIZE=30></TD>")
	Response.write("	    </TR>")
	Response.write("	    <TR>")
	Response.write("	     <TD VALIGN=top BGCOLOR=#" & personalInformationBg & "><FONT FACE=Arial SIZE=-1>AIM:</FONT></TD>")
	Response.write("	     <TD BGCOLOR=#" & personalInformationBg & "><INPUT TYPE=text NAME=AIM SIZE=30></TD>")
	Response.write("	    </TR>")
	Response.write("	    <TR>")
	Response.write("	     <TD VALIGN=top BGCOLOR=#" & personalInformationBg & "><FONT FACE=Arial SIZE=-1>Yahoo!:</FONT></TD>")
	Response.write("	     <TD BGCOLOR=#" & personalInformationBg & "><INPUT TYPE=text NAME=Yahoo SIZE=30></TD>")
	Response.write("	    </TR>")
	Response.write("	    <TR>")
	Response.write("	     <TD VALIGN=top BGCOLOR=#" & personalInformationBg & "><FONT FACE=Arial SIZE=-1>ICQ:</FONT></TD>")
	Response.write("	     <TD BGCOLOR=#" & personalInformationBg & "><INPUT TYPE=text NAME=ICQ SIZE=30></TD>")
	Response.write("	    </TR>")
	Response.write("	    <TR>")
	Response.write("	     <TD VALIGN=top BGCOLOR=#" & personalInformationBg & "><FONT FACE=Arial SIZE=-1>Homepage:</FONT></TD>")
	Response.write("	     <TD BGCOLOR=#" & personalInformationBg & "><INPUT TYPE=text NAME=Homepage SIZE=30 VALUE='http://'></TD>")
	Response.write("	    </TR>")
	Response.write("	    <TR>")
	Response.write("	     <TD VALIGN=top BGCOLOR=#" & msgBg & "><FONT FACE=Arial SIZE=-1>Message:</FONT></TD>")
	Response.write("	     <TD BGCOLOR=#" & msgBg & "><TEXTAREA NAME=Message cols=28 rows=8></TEXTAREA></TD>")
	Response.write("	    </TR>")
	Response.write("	    <TR>")
	Response.write("	     <TD BGCOLOR=#" & buttonBg & ">&nbsp;</TD>")
	Response.write("	     <TD BGCOLOR=#" & buttonBg & " VALIGN=top><INPUT TYPE=submit NAME=Submit VALUE='Sign the Guestbook'></TD>")
	Response.write("	    </TR>")
	Response.write("	  </TABLE>")
	Response.write("	</FORM>")
	Response.write("")
	Response.write("	<BR>")
	Response.write("")
	Response.write("       </TD>")
	Response.write("      </TR>")
	Response.write("    </TABLE>")
	Response.write("   </TD>")
	Response.write("  </TR>")
	Response.write("</TABLE>")
END IF

'-------------------------------/\------/\-------------------------------'
'-------------------------------||-CODE-||-------------------------------'
'-------------------------------||------||-------------------------------'
%>

<!--#set var="queryString" value="$QUERY_STRING" -->
<!--#if expr="$queryString = /perform=post/" || expr="$queryString = /perform=admin&act=cancel/" || expr="$queryString = /perform=admin&act=createBackup/" || expr="$queryString = /perform=admin&act=rest/reBackup/" || expr="$queryString = /perform=admin&act=save/" || expr="$queryString = /perform=admin&act=delete/" || expr="$queryString = /perform=admin&act=writeHeader/" || expr="$queryString = /perform=admin&act=writeFooter/" || expr="$queryString = /perform=admin&act=logout/" || expr="$queryString = /perform=admin&act=checkPassword/" -->
<!--#include file="footer.asp" -->
<% 'To support and respect the Author (Leigh McCulloch), please do not remove the code below.
Response.write("<BR><BR><TABLE><TR><TD><A HREF=http://skgb.sf.net/ TARGET=_blank><IMG SRC='http://shokem.hypermart.net/images/shokem.gif' BORDER=0 VSPACE=4></A></TD><TD><FONT FACE=Arial SIZE=-2>This guestbook uses <A HREF=http://skgb.sf.net/ TARGET=_blank>SKGB</A> to store and display its posts.<BR>Copyright &copy; 2002 Leigh McCulloch, All Rights Reserved.</FONT></TD></TR></TABLE>")%>
<!--#endif -->
